all_tests = {
        'replace1': [
            ["hello", "e", "a"], "hallo",
            ["bonjour", "u", "z"], "bonjozr",
            ["mississipi", "i", "g"], "mgssissipi"],
        'replace_all': [
            ["hello", "e", "a"], "hallo",
            ["bonjour", "u", "z"], "bonjozr",
            ["mississipi", "i", "g"], "mgssgssgpg"],
        'find': [
            ["hello", "hello"], 0,
            ["hello", "ello"], 1,
            ["hello", "lo"], 3,
            ["hello", "bonjour"], -1,
            ["hello", "hell"], 0,
            ["hello", "ll"], 2],
        'remove': [
            ["hello", "hell"], "o",
            ["Ceci n'est pas une chaine de caracteres", "Ceci n'est pas "], "une chaine de caracteres",
            ["bonjour", "salut"], "bonjour",
            ["hello", "ll"], "heo"],
        'remove_each': [
            ["hello", "l"], "heo",
            ["""String literals are written in single or double quotes: 'xyzzy', "frobozz". See String literals for more about string literals.""", "String literals"], """ are written in single or double quotes: 'xyzzy', \"frobozz\". See  for more about string literals."""],
        'reverse': [
            ["hello"], "olleh",
            ["Esope reste ici et se repose"], "esoper es te ici etser eposE"],
        'remove_spaces': [
            ["There are four distinct numeric types: plain integers, long integers, floating point numbers, and complex numbers."], "Therearefourdistinctnumerictypes:plainintegers,longintegers,floatingpointnumbers,andcomplexnumbers."],
        'palindrome': [
            ["hello"], False,
            ["Esope reste ici et se repose"], True],
        'crypt': [
            ["hello"], 'ifmmp',
            ['hello', 10], 'rovvy',
            ['hello', 100], '\xcc\xc9\xd0\xd0\xd3',
            ['bonjour', 4], 'fsrnsyv']
        }
def run_all_tests():
    for key,val in all_tests.iteritems():
        test(eval(key), *val)
    print
from sys import stdout as out
def test(func, *args):
    if len(args) % 2 == 0:
        for a,b in zip(args[::2], args[1::2]):
            if func(*a) == b:
                out.write(".")
            else:
                print "\nError in tests for function {}.".format(func.__name__)
                print "\tArguments: {}, expected: {}, got: {}.".format(a, b, func(*a))
    else:
        print "Error"
        exit()

def replace1(string, old, new):
    index = -1
    for letter in string:
        index += 1
        if letter == old:
            return string[:index] + new + string[index+1:]
    return string
def replace_all(string, old, new):
    if replace1(string,old,new) != string:
        return replace_all(replace1(string, old, new), old, new)
    else:
        return replace1(string, all, new)
def find(orig, pattern):
    length = len(pattern)
    for pos in range(len(orig) - length + 1):
        if orig[pos:pos+length] == pattern:
            return pos
    return -1
def remove(orig, pattern):
    pos = find(orig, pattern)
    length = len(pattern)
    if pos != -1:
        return orig[:pos] + orig[pos+length:]
    else:
        return orig
def remove_each(orig, pattern):
    while remove(orig, pattern) != orig:
        orig = remove(orig, pattern)
    return orig
def reverse(orig):
    return orig[-1::-1]
def remove_spaces(orig):
    return remove_each(orig, " ")
def palindrome(string):
    return remove_spaces(string.upper()) == reverse(remove_spaces(string.upper()))
def crypt(string, dist=1):
    result = ""
    for letter in string:
        result += chr(ord(letter)+dist)
    return result

run_all_tests()
