# =====================================================
#  The main functions of this script are adapted from
#  http://www.python-course.eu/towers_of_hanoi.php
# =====================================================

# Defined globals for "show_hanoi" to work.
g_source = []
g_helper = []
g_target = []
g_n = 0

def show_disk(size, max_size):
    print( " "*(1+max_size-size) + "="*size + "|" + "="*size + " "*(1+max_size-size), end="" )

def show_hanoi():
    for i in range(3):
        print()
    space = "     "
    for i in range( g_n-1,-1,-1 ):
        print (space,end="")
        show_disk((g_source+g_n*[0])[i],g_n)
        print (space,end="")
        show_disk((g_helper+g_n*[0])[i],g_n)
        print (space,end="")
        show_disk((g_target+g_n*[0])[i],g_n)
        print()
    print (space,end="")
    print( ("#"*(2*g_n+3) + space)*3 )
    print()
    dummy = input()

def recursive_hanoi(n, source, helper, target):
    if n > 0:
        # move tower of size n - 1 to helper:
        recursive_hanoi(n - 1, source, target, helper)
        # move disk from source peg to target peg
        if source:
            disk = source.pop()
            target.append(disk)
        show_hanoi()
        # move tower of size n-1 from helper to target
        recursive_hanoi(n - 1, helper, source, target)


def hanoi(n):
    global g_source
    global g_helper
    global g_target
    global g_n
    source = list(range(n,0,-1))
    helper = []
    target = []
    g_source = source
    g_helper = helper
    g_target = target
    g_n = n
    for i in range(50):
        print()
    show_hanoi()
    recursive_hanoi ( n, source, helper, target )

# Example call.
hanoi(5)
