import timeit

def factorial_recursive( n ):
    if n < 1:
        res = 1
    else:
        res = n * factorial_recursive( n-1 )
    return res

def factorial_iterative( n ):
    res = 1
    for i in range(2,n+1):
        res *= i
    return res

def time_compare( n ):
    tr = timeit.timeit("factorial_recursive("+str(n)+")", setup="from __main__ import factorial_recursive")
    ti = timeit.timeit("factorial_iterative("+str(n)+")", setup="from __main__ import factorial_iterative")
    print( "Comparaison des temps d'exécution pour n = "+str(n)+":" )
    print( "   récursif = ", tr, "secondes" )
    print( "   iteratif = ", ti, "secondes" )
    print()
    print( "   ratio = ", tr/ti )
    print()
    
time_compare( 20 )
